module ("ChapterListData",package.seeall)
--章节列表数据
ChapterTemplet = {
	OnlyId  = "",   --章节的唯一标识
  	Id 		= 0, 	--章节id
	LvLow 	= 0, 	--等级区间的最低等级 （暂时无用）
	LvHig 	= 0, 	--等级区间的最高等级 （暂时无用）
	Pass 	= 0,  	--章节通过的npc数量  （暂时无用）
	All 	= 0, 	--章节npc总量		 （暂时无用）
	State   = 0,    --章节状态 0--没打 1--打通  2--正在打


	ifOpenFirst = 0, --是否第一次通关 --0：不是 1是
}


local ChapterDataList = {}
local curChapterId = 0  --记录当前所选章节的id

local remNextCPTid = 0  --临时记录下一个要切换的章节id 

local remNextCharpterEffect = {} --记录是否需要下一关特效 

--添加章节数据 目前没用到 章节数据一次性全部过来
function addCharpterData( _data )
	table_insert( ChapterDataList, _data )
	if _data["State"] == 1 then
		remNextCharpterEffect[_data["Id"]] = 1 
	else
		remNextCharpterEffect[_data["Id"]] = 0
	end
end
function clearCharpterData()
	ChapterDataList = {}
end
--获取章节列表数据
function getCharpterDataList()
	return ChapterDataList
end
function setCurCharpterId(_Onlyid)
	local _id = 0
	for i=1, #ChapterDataList do
		if ChapterDataList[i]["OnlyId"] == _Onlyid then
			_id = i
		end
	end

	curChapterId = _id
	print("setCurCharpterId id == " .. _id)
	for i=1, #remNextCharpterEffect do
		print("i == " .. ChapterDataList[i]["State"])
		if i < _id then --本章之前不显示
			remNextCharpterEffect[i] = 0 -- 0 不显示下一关特效
		elseif i == _id and ChapterDataList[i]["State"] ~= 1 then
			remNextCharpterEffect[i] = 0
			print("-------------------->")
		end
	end
end
--是否显示当前关卡下一关的特效
function getifViewNextCharpterEffect()
	print("getifViewNextCharpterEffect idcur === " .. curChapterId .. remNextCharpterEffect[curChapterId])
	if remNextCharpterEffect[curChapterId] == 1 then
		return true --显示
	else
		return false --不显示
	end
end
function setifViewNextCharpterEffect( )
	print("setifViewNextCharpterEffect == " .. curChapterId)
	remNextCharpterEffect[curChapterId] = 0
end
--获取当前章节的id
function getCurCharpterId()
	return curChapterId
end
--获取当前章节的本地数据索引
function getCurCharpterLocalIdx()
	local num = #ChapterDataList
	for i=1, num do
		if curChapterId == ChapterDataList[i]["Id"] then
			return i
		end
	end
	return 0
end
--获取当前章节通关状态
function getCurCharpterState()
	local num = #ChapterDataList
	for i=1, num do
		if curChapterId == ChapterDataList[i]["Id"] then
			return ChapterDataList[i]["State"]
		end
	end
end
--_wch:0上一章 1下一章 
function resetRemCharpterIdFromBtn(_wch)
	local curidx = getCurCharpterLocalIdx()
	local maxCptSize = #ChapterDataList
	if _wch == 0 then --上一章
		if curidx == 1 then --当前是第一章
			--todo 提示没有上一章了
			--Pop3_TS_Result.enterUI( "没有上一章了"  )
			return 0
		else
			remNextCPTid = ChapterDataList[curidx-1]["Id"]
		end
	elseif _wch == 1 then --下一章
		if curidx == maxCptSize then
			--todo 提示没有下一章了
			--Pop3_TS_Result.enterUI( "没有下一章了"  )
			return 0
		elseif ChapterDataList[curidx+1]["State"] == 0 then --尚未开启
			--Pop3_TS_Result.enterUI( "尚未开启"  )
			return 0
		else
			remNextCPTid = ChapterDataList[curidx+1]["Id"]
		end
	end
	return 1
end
--通过本地数据数组索引修改当前章节id的记录 用于章节选择
function resetRemCharpterIdFromLocalIdx(_locIdx)
	if ChapterDataList[_locIdx]["State"] == 0 then
		return 0 --返回0 提示章节未开启
	end
	remNextCPTid = ChapterDataList[_locIdx]["Id"]
	return 1
end
--获取即将申请的章节id
function getRemNextCptId()
	return remNextCPTid
end
--通过章节id获取此章节的数据
function getCharpterDataFromCptId( _id)
	local num = #ChapterDataList
	for i=1, num do
		if _id == ChapterDataList[i]["Id"] then
			return ChapterDataList[i]
		end
	end
end

--修改章节状态
function flushCharpterState(_id, _passNum, _stata )
	local num = #ChapterDataList
	for i=1, num do
		if _id == ChapterDataList[i]["Id"] then
			ChapterDataList[i]["Pass"] = _passNum
			ChapterDataList[i]["State"] = _stata
			if _stata == 1 then --记录第一次打通
				ChapterDataList[i]["ifOpenFirst"] = 1
				remNextCharpterEffect[i] = 1
				print("--------------ksjdkjsljsljfk-------------------")
			end
			return
		end
	end
end
--获取当前章节是否第一次打通
function getCharpterOpenFirst(_id)
	local num = #ChapterDataList
	for i=1, num do
		if _id == ChapterDataList[i]["Id"] and ChapterDataList[i]["ifOpenFirst"] == 1 then
			ChapterDataList[i]["ifOpenFirst"] = 0 --使用过后恢复数据
			return true
		end
	end
	return false
end


---------------------------
ChapterPassTemplet = {
	_type 	= 0, --获取奖励的类型  1为装备 2为金币 3为银币 4为军功 5为粮草
	_id 	= 0, --获取奖励的id
	_num 	= 0, --获取奖励的数量
}
local charpterPassList = {}

function addCharpterPassData(_data)
	table_insert(charpterPassList, _data)
end
function clearCharpterPassData()
	charpterPassList = {}
end
function getCharpterPassJiangLi()
	return charpterPassList
end