module ("FormationData",package.seeall)
--阵型数据
generalOnPosTemplet = {
	generalPos    = 0,  --将领所在位置
	generalIdx 	  = "",  --新结构代表将领的唯一标识。老的结构意义：将领idx  没人是-1 代表将领数组的下标，具体将领id去将领数组里去找

}

oneFormationTemplet = {
	FormationOnlyId = "",
	FormationId 	= 0, --阵型id
	FormationOpenNum= 0, --阵型开放数量
	generalOnPosData= {},
}

local _team = {
	IconId 			= 0, --将领头像id
	Lv 				= 0, --将领等级
	Name 			= "",--将领名字
	formation_count = 0, --阵型数量
	defFormation 	= "", --默认阵型
	oneFormationData= {}, 
} --我的阵型


-----------------------------------
oneBossFormationTemplet = {
	Pos 		= 0, --位置
	GeneralId 	= 0, --将领id
	UnitId 		= 0, --小兵id
	GoddessId 	= 0, --女神id
	Lv 			= 0, --将领等级
	CurHp 		= 0, --当前带兵量
	MaxHp 		= 0, --最大带兵量
	CurSp 		= 0, --当前气值
	MaxSp 		= 0, --最大气值
	GodsStart   = 0, --女神星级
}
local _boss = {
	Name 			= "",--将领名字
	Lv 				= 0, --将领等级
	Power 			= 0, --将领战斗力
	Weather 		= 0, --战斗天气 1:晴天 2阴天 3雨天
	Count 			= 0, --敌人个数
	oneBossFormationData = {},
} --敌人阵型


--------------战报阵型-------------------------------------

local ifReportState = false  --是否是战报阵型

local leftTeam = {
	Name 			= "",--将领名字
	Lv 				= 0, --将领等级
	Power 			= 0, --将领战斗力
	Weather 		= 0, --战斗天气--无用，天气来自战斗数据
	Count 			= 0, --敌人个数
	oneBossFormationData = {},
}
local rightTeam = {
	Name 			= "",--将领名字
	Lv 				= 0, --将领等级
	Power 			= 0, --将领战斗力
	Weather 		= 0, --战斗天气
	Count 			= 0, --敌人个数
	oneBossFormationData = {},
}


function getFightWeather()
	return _boss["Weather"]
end

function  setFormationFromKey( _key, _value)
	_team[_key] = _value
end
--获取当前阵型序列
function getDefFormation()
	local defformation = _team["defFormation"]
	local dataList = _team["oneFormationData"]
	for i=1,#dataList do
		if defformation == dataList[i]["FormationOnlyId"] then
			return i
		end
	end
	return 0
end
function getDefFormationData()
	local defformation = _team["defFormation"]
	local dataList = _team["oneFormationData"]
	for i=1,#dataList do
		if defformation == dataList[i]["FormationOnlyId"] then
			return dataList[i]
		end
	end
	return 0
end
function getFormationOnlyIdFromIdx( _idx )
	-- body
	local dataList = _team["oneFormationData"]
	--if dataList[_idx]["FormationOnlyId"] ~= "" then
		return dataList[_idx]["FormationOnlyId"]
	--else
	--	return ""
	--end
end

function setDefFormation( _ZhenXingIdx )
	
	_team["defFormation"] = _team["oneFormationData"][_ZhenXingIdx]["FormationOnlyId"]
end
function addFormation( _data )
	table_insert(_team["oneFormationData"], _data)
end
--设置一个将领的下阵动作
function setTeamerDownFromPos(_zhenXinIndex, _pos)
	local _FormationData = _team["oneFormationData"][_zhenXinIndex]
	local _num = _FormationData["FormationOpenNum"]
	for i=1, _num do
		local data = _FormationData["generalOnPosData"][i]
		if data["generalPos"] == _pos then
			_team["oneFormationData"][_zhenXinIndex]["generalOnPosData"][i]["generalIdx"] = ""
		end
	end
end

--判断当前将领是否在这个阵型上
function getIfGeneralOnThisFormation(_zhenXinIndex, _generalIdx)
	local _FormationData = _team["oneFormationData"][_zhenXinIndex]
	local _num = _FormationData["FormationOpenNum"]
	for i=1, _num do
		local data = _FormationData["generalOnPosData"][i]
		if data["generalIdx"] == _generalIdx then
			return true
		end
	end
	return false
end
--当前位置是否有将领，有返回当前位置结构
function getIfHaveTeamOnPos( _zhenXinIndex, _pos  )

	local _FormationData = _team["oneFormationData"][_zhenXinIndex]
	local _num = _FormationData["FormationOpenNum"]
	for i=1, _num do
		local data = _FormationData["generalOnPosData"][i]
		if data["generalPos"] == _pos then
			return true, data
		end
	end
	return false, nil
end
--获取当前阵型的开启数量
function getOpenTeamNum(_zhenXinIndex)
	return _team["oneFormationData"][_zhenXinIndex]["FormationOpenNum"]
end
--更新当前阵型当前位置上的将领的idx，就是换将
function resetTeamIdxOnPos(_zhenXinIndex, _pos, _newIdx)
	local _FormationData = _team["oneFormationData"][_zhenXinIndex]
	local _num = _FormationData["FormationOpenNum"]
	for i=1, _num do
		local data = _FormationData["generalOnPosData"][i]
		if data["generalPos"] == _pos then
			if data["generalIdx"] == _newIdx then
				return false
			else
				_team["oneFormationData"][_zhenXinIndex]["generalOnPosData"][i]["generalIdx"] = _newIdx
				return true
			end
		end
	end
	return false
end



--阵型修改,交换位置
function changeTeamPos(_zhenXinIndex, _pos1, _pos2)
	local index1 = nil
	local index2 = nil
	local _FormationData = _team["oneFormationData"][_zhenXinIndex]
	local _num = _FormationData["FormationOpenNum"]
	for i=1, _num do
		local data = _FormationData["generalOnPosData"][i]
		if data["generalPos"] == _pos1 then
			index1 = i
		elseif data["generalPos"] == _pos2 then
			index2 = i
		end
	end
	if index1 == nil or index2 == nil then
		return false
	end

	local generalIdx 	= _team["oneFormationData"][_zhenXinIndex]["generalOnPosData"][index1]["generalIdx"]

	_team["oneFormationData"][_zhenXinIndex]["generalOnPosData"][index1]["generalIdx"] = _team["oneFormationData"][_zhenXinIndex]["generalOnPosData"][index2]["generalIdx"]
	_team["oneFormationData"][_zhenXinIndex]["generalOnPosData"][index2]["generalIdx"] = generalIdx

	return true
end

function getTeamFormationCount()
	return _team["formation_count"]
end

function getTeamFormationDataFromIndex(_FormationIndex)
	return _team["oneFormationData"][_FormationIndex]
end
function getGeneralOnPosDataFromIndex(_FormationIndex, _posIndex) 
	return _team["oneFormationData"][_FormationIndex]["generalOnPosData"][_posIndex]
end

--阵型清除
function clearFormation( _Who )
	if 0 == _Who then--自己
		_team["oneFormationData"] = {}
	elseif 1 == _Who then
		_boss = {}
		_boss["oneBossFormationData"] = {}
	end
end
----------boss阵型操作-----------------------
function  setBossFormationFromKey( _key, _value)
	_boss[_key] = _value
end
function addBossFormation( _data )
	table_insert(_boss["oneBossFormationData"], _data)
end
--当前位置是否有敌人，有返回当前位置结构
function getIfHaveBossOnPos( _pos )
	local _num = _boss["Count"]
	for i=1, _num do
		local data = _boss["oneBossFormationData"][i]
		if data["Pos"] == _pos then
			return true, data
		end
	end
	return false, nil
end
--获取敌方阵型的玩家名字和等级
function getBossNameAndLv()
	return _boss["Name"], _boss["Lv"], _boss["Power"]
end


-------------------------------------------------
function setReportState( _state )
	ifReportState = _state
end
function getReportState()
	return ifReportState
end
--获取战报玩家名字和等级
function getReportNameAndLvFromLeOrRi(leOrRi)
	if leOrRi == 0 then
		return leftTeam["Name"], leftTeam["Lv"]
	else
		return rightTeam["Name"], rightTeam["Lv"]
	end
end

function clearAllReportTeam(leOrRi)
	if leOrRi == 0 then
		leftTeam["oneBossFormationData"] = {}
	else
		rightTeam["oneBossFormationData"] = {}
	end
end

--leOrRi  0：左边 1：右边
function setReportFormationFromKey( leOrRi, _key, _value )
	if leOrRi == 0 then
		leftTeam[_key] = _value
	elseif leOrRi == 1 then
		rightTeam[_key] = _value
	end
end
function addReportFormation( leOrRi, _data )
	if leOrRi == 0 then
		table_insert(leftTeam["oneBossFormationData"], _data)
		local num = #(leftTeam["oneBossFormationData"])
		print("leftNum == " .. leftTeam["oneBossFormationData"][num]["Pos"] )
	elseif leOrRi == 1 then
		table_insert(rightTeam["oneBossFormationData"], _data)
	end
end

--当前位置是否有敌人，有返回当前位置结构
function getIfHaveBossOnReportFormationPos( leOrRi, _pos )
	if leOrRi == 0 then
		local _num = leftTeam["Count"]
		for i=1, _num do
			--print("i == " .. i)
			local data = leftTeam["oneBossFormationData"][i]
			if data["Pos"] == _pos then
				return true, data
			end
		end
		return false, nil
	elseif leOrRi == 1 then
		local _num = rightTeam["Count"]
		for i=1, _num do
			local data = rightTeam["oneBossFormationData"][i]
			if data["Pos"] == _pos then
				return true, data
			end
		end
		return false, nil
	end
end

--战斗tips数据获取,根据位置获取详细tips数据，否则，没人返回false
function getTipsMessageFrom( _pos )
	local name = ""
	local lv = ""
	local bingzhong = ""
	local zhanfa = ""
	
	local nvshen = ""
	local jeneralId =1
	--气要动态的从战斗数据里获得
	--local bingli = ""
	--local nvshenqi = ""

	if ifReportState then --战报
		local bosNum = 0
		local bosData = nil
		if _pos <= 9 then --左侧阵型
			bosNum  = leftTeam["Count"]
			bosData = leftTeam["oneBossFormationData"]
		else --右侧阵型	
			bosNum  = rightTeam["Count"]
			bosData = rightTeam["oneBossFormationData"]
		end
			for i=1, bosNum do
				local onedata   = bosData[i]
				if _pos == onedata["Pos"] then --这个位置上的

					jeneralId = onedata["GeneralId"] --将领id
					local godId 	= onedata["GoddessId"]
					local unitId 	= onedata["UnitId"]

					lv = "Lv: " .. onedata["Lv"]
					local jeneralDes = Des.getGeneralDesFromId( jeneralId )
					name = jeneralDes["generalName"]

					local unitDes = Des.getUnitDesFromId(unitId)
					bingzhong = unitDes["unitName"]
					if godId == 0 then
						nvshen = "无"
					else
						local godDes = Des.getGoddessDesFromId(godId)
						local godType = godDes["goddessType"]
						--1火2水3风
						if godType == 1 then
							nvshen = "火"
						elseif godType == 2 then
							nvshen = "水"
						elseif godType == 3 then
							nvshen = "风"
						end
					end

					local skillId = jeneralDes["SpAttackID"]
						if skillId ~= 0 then --有技能
							local desSkill = Des.getSpAttackDesFromId( skillId )
							zhanfa = desSkill["SpAttackName"] 
						else
							zhanfa = "无"
						end
					return true, name, lv,bingzhong,zhanfa,nvshen,jeneralId
				end
			end
	else --非战报情况
		if _pos <= 9 then --玩家阵型
			local formationData = getDefFormationData()
			local openNum = formationData["FormationOpenNum"]
			local oneFormationData = formationData["generalOnPosData"]
			for i=1, openNum do
				local onedata = oneFormationData[i]
				if onedata["generalPos"] == _pos then --查找到阵型上所需位置
					local jeneralIdx = onedata["generalIdx"]
					if jeneralIdx == "" then --这个位置没人
						return false
					else
						local jeneralData = GeneralData.getYesGeneralDataFormIdx(jeneralIdx) --获取相应上阵将领的数据
						jeneralId = jeneralData["GenneralId"] --将领id
						lv = "Lv: " .. jeneralData["Lv"]
						local jeneralDes = Des.getGeneralDesFromId( jeneralId )
						name = jeneralDes["generalName"]

						local UnitId = jeneralDes["generalUnitID"] --将领的兵种id
						local unitDes = Des.getUnitDesFromId(UnitId)
						bingzhong = unitDes["unitName"]

						local godId = jeneralData["GoddessId"] --女神id
						if godId == 0 then
							nvshen = "无"
						else
							local godDes = Des.getGoddessDesFromId(godId)
							local godType = godDes["goddessType"]
							--1火2水3风
							if godType == 1 then
								nvshen = "火"
							elseif godType == 2 then
								nvshen = "水"
							elseif godType == 3 then
								nvshen = "风"
							end
						end
						local skillId = jeneralDes["SpAttackID"] --本地将领表记录将领技能
						if skillId ~= 0 then --有技能
							local desSkill = Des.getSpAttackDesFromId( skillId )
							zhanfa = desSkill["SpAttackName"] 
						else
							zhanfa = "无"
						end
						return true, name, lv,bingzhong,zhanfa,nvshen,jeneralId
					end
				end
			end
		else
			local bosNum = _boss["Count"]
			local bosData = _boss["oneBossFormationData"]
			for i=1, bosNum do
				local onedata   = bosData[i]
				if _pos == onedata["Pos"] then --这个位置上的

					jeneralId = onedata["GeneralId"] --将领id
					local godId 	= onedata["GoddessId"]
					local unitId 	= onedata["UnitId"]

					lv = "Lv: " .. onedata["Lv"]
					local jeneralDes = Des.getGeneralDesFromId( jeneralId )
					name = jeneralDes["generalName"]

					local unitDes = Des.getUnitDesFromId(unitId)
					bingzhong = unitDes["unitName"]

					if godId == 0 then
						nvshen = "无"
					else
						local godDes = Des.getGoddessDesFromId(godId)
						local godType = godDes["goddessType"]
						--1火2水3风
						if godType == 1 then
							nvshen = "火"
						elseif godType == 2 then
							nvshen = "水"
						elseif godType == 3 then
							nvshen = "风"
						end
					end
					local skillId = jeneralDes["SpAttackID"]
						if skillId ~= 0 then --有技能
							local desSkill = Des.getSpAttackDesFromId( skillId )
							zhanfa = desSkill["SpAttackName"] 
						else
							zhanfa = "无"
						end
					return true, name, lv,bingzhong,zhanfa,nvshen,jeneralId
				end
			end
		end
	end

	return false
end