module ("TaskDailyData",package.seeall)


Spl_Templet = {
	TaskType 	= 0,  --任务需求的类型
	TaskState 	= 0,  --对应的完成状态 0为未完成 1为已完成
}

Dai_Templet = {
	TaskId 		= 0,
	TaskType 	= 0, --1为征讨npc2为攻击玩家3为强化装备4为升级女神5为获得银币
	ProCur 		= 0, --任务完成进度
	ProMax 		= 0, --任务完成进度条件
	State 		= 0, --任务状态0为未接受1为已接受2为已完成
	Merit 		= 0, --任务完成奖励的功勋值
}
Mer_Templet = {
	MeritPosint 	= 0, --对应箱子的功勋值
	BoxRewardType	= 0, --箱子的奖励类型 1银币 2金币 3军功 4军粮 5军令 6荣誉
	BoxRewardValue	= 0, --对应的奖励值
	BoxRewardId 	= 0, --箱子奖励的装备Id
	BoxRewardNum 	= 0, --箱子奖励的装备数量
	BoxState 		= 0, --箱子的状态 0为功勋不足领取不到  1为未领取 2为已领取
}


local DailyTaskData = {
	TaskCur 		= 0, --已完成任务数量
	TaskMax 		= 0, --最大任务数量
	AutoId 			= 0, --已经自动完成的任务Id
	AutoTime		= 0, --自动完成的CD事件
	MeritCur 		= 0, --当前功勋值
	MeritMax 		= 0, --最大功勋值
	RewardType 		= 0,  --特殊事件奖励类型1银币2金币3军功4军粮5军令6荣誉
	RewardValue1 	= 0, --特殊事件奖励类型的对应数值
	RewardEquipId 	= 0, --特殊事件奖励的装备id
	RewardEquipNum 	= 0, --特殊事件奖励的装备个数
	RewardMeritNum 	= 0, --特殊事件奖励的功勋
	FlushSplNeed 	= 0, --刷新特殊事件所需金币
	FlushTaskNeed 	= 0, --刷新任务列表所需金币

	SplNeedSize 	= 0, --特殊事件完成的条件任务的数量 
	DailyTaskSize 	= 0, --任务列表数量
	MeritBoxSize 	= 0, --功勋箱子个数
}

local SplTaskNeedList = {} --特殊任务的触发列表
local BoxMerList = {} --功勋箱子数据列表
local DailTaskList = {} --任务列表

function clearAllData()
	DailyTaskData["TaskCur"] 		= 0
	DailyTaskData["TaskMax"] 		= 0
	DailyTaskData["AutoId"] 		= 0
	DailyTaskData["AutoTime"] 		= 0
	DailyTaskData["MeritCur"] 		= 0
	DailyTaskData["MeritMax"] 		= 0
	DailyTaskData["RewardType"] 	= 0
	DailyTaskData["RewardValue1"] 	= 0
	DailyTaskData["RewardEquipId"] 	= 0
	DailyTaskData["RewardEquipNum"] = 0
	DailyTaskData["RewardMeritNum"] = 0
	DailyTaskData["FlushSplNeed"] 	= 0
	DailyTaskData["FlushTaskNeed"] 	= 0
	DailyTaskData["SplNeedSize"] 	= 0
	DailyTaskData["DailyTaskSize"] 	= 0
	DailyTaskData["MeritBoxSize"] 	= 0
	SplTaskNeedList = {}
	BoxMerList = {}
	DailTaskList = {}
end

function setDataPub(_TaskCur, _TaskMax, _AutoId, _AutoTime, _MeritCur, _MeritMax, _RewardType, _RewardValue1, _RewardEquipId, _RewardEquipNum, _RewardMeritNum, _FlushSplNeed, _FlushTaskNeed, _SplNeedSize, _DailyTaskSize, _MeritBoxSize )
	DailyTaskData["TaskCur"] 		= _TaskCur
	DailyTaskData["TaskMax"] 		= _TaskMax
	DailyTaskData["AutoId"] 		= _AutoId
	if _AutoId == 0 then
		_AutoTime = 0
	end
	DailyTaskData["AutoTime"] 		= _AutoTime
	DailyTaskData["MeritCur"] 		= _MeritCur
	DailyTaskData["MeritMax"] 		= _MeritMax
	DailyTaskData["RewardType"] 	= _RewardType
	DailyTaskData["RewardValue1"] 	= _RewardValue1
	DailyTaskData["RewardEquipId"] 	= _RewardEquipId
	DailyTaskData["RewardEquipNum"] = _RewardEquipNum
	DailyTaskData["RewardMeritNum"] = _RewardMeritNum
	DailyTaskData["FlushSplNeed"] 	= _FlushSplNeed
	DailyTaskData["FlushTaskNeed"] 	= _FlushTaskNeed
	DailyTaskData["SplNeedSize"] 	= _SplNeedSize
	DailyTaskData["DailyTaskSize"] 	= _DailyTaskSize
	DailyTaskData["MeritBoxSize"] 	= _MeritBoxSize
end
function addSplTaskNeedList( _data )
	table_insert(SplTaskNeedList, _data )
end
function addBoxMerList( _data )
	table_insert(BoxMerList, _data )
end
function addDailTaskList( _data )
	table_insert(DailTaskList, _data )
end

function getDailyTaskData()
	return DailyTaskData
end
function getSplTaskNeedList()
	return SplTaskNeedList
end
function getBoxMerList()
	return BoxMerList
end
function getDailTaskList()
	return DailTaskList
end
--获取任务状态
function getDaiTaskState()
	local Num = #DailTaskList
	--由于同时不可能存在多个已接受数据，所以判断接收后可以立即返回
	for i=1, Num do
		local data= DailTaskList[i]
		if data["State"] == 1 then --1为已接受
			return i, 1
		elseif data["State"] == 2 then --2为已完成
			return i, 2
		end
	end
	return 0, 0
end
--检测是否需要显示小红点
function checkIfRedPoint()
	local Num = #DailTaskList
	--由于同时不可能存在多个已接受数据，所以判断接收后可以立即返回
	for i=1, Num do
		local data= DailTaskList[i]
		if data["State"] == 2 then --2为已完成
			return true
		end
	end
	return false
end
local lbl_CDAutoTask = nil
function setCDlbl(_lbl)
	lbl_CDAutoTask = _lbl
end
function clearCDlbl()
	lbl_CDAutoTask = nil
end

function flushAuToTaskCDTime()
	if DailyTaskData.AutoTime > 0 then
		DailyTaskData.AutoTime = DailyTaskData.AutoTime - 1
	else
		if lbl_CDAutoTask ~= nil then
			print("flushAuToTaskCDTime 2...")
			--lbl_CDAutoTask:setVisible(false)
			lbl_CDAutoTask = nil
		end
	end
	if lbl_CDAutoTask ~=  nil and DailyTaskData.AutoTime > 0 then
		print("flushAuToTaskCDTime 3...")
		local str = PT.gerStringFromMilSecond( DailyTaskData.AutoTime )
		print("flushAuToTaskCDTime 3...  == " .. str)
		lbl_CDAutoTask:setVisible(true)
		lbl_CDAutoTask:setText( str )
	end
end