module ("TaskMainData",package.seeall)
--[[
Kind类型:
	1建筑升级    建筑ID  提升至等级
	2通关NPC    关卡ID   NPCID
	3获得某件装备     装备ID
	4将装备强化至某个级别     装备ID    强化等级
	5招募到某个武将      武将ID
	6某个武将提升至某个级别    武将ID   等级
	7某个武将上阵         武将ID
	8玩家官职到达某个级别    官职等级
	9占领农田
	10占领银矿
	11玩家某个女神升级至某个等级    女神ID   等级
	12某个女神升级至某个星级          女神id   星级
	13迁移至某个地区       地区等级上限
--]]
TaskMainTemplet = {
	MainTaskId 	= 0,
	State 		= 0, --1完成 0未完成
	Kind 		= 0, --类型
	Ratio1 		= 0, --参数1
	Ratio2 		= 0, --参数2
	Ratio3  	= 0, --参数3
	RewardType 	= 0, --奖励类型 1银币 2金币 3军功 4军粮 5军令 6荣誉
	RewardValue = 0 --奖励值
}

local dataList = {}

function getStateFromId( _id )
	local size = #dataList
	for i=1, size do
		local data = dataList[i]
		if data["MainTaskId"] == _id and data["State"] == 0 then
			return true
		end
	end
	return false
end
function getDataFromId(_id)
	local size = #dataList
	for i=1, size do
		local data = dataList[i]
		if data["MainTaskId"] == _id then
			return data
		end
	end
	return nil	

end
--监测是否需要显示小红点
function checkIfNeedRedPoint()
	local size = #dataList
	for i=1, size do
		if dataList[i]["State"] == 1 then
			return true
		end
	end
	return false
end
function clearMainTaskDataList()
	dataList = {}
end

function addMainTaskData(_data)
	table_insert(dataList, _data)
end

function getMainTaskDatalist()
	return dataList
end
--为任务面板获取任务状态和数据，有完成的任务，获取第一个完成的任务，没有则获取第一个未完成的任务
function getMainTaskStateAndData()
	local size = #dataList
	for i=1, size do
		local data = dataList[i]
		if data["State"] == 1 then
			return true, data
		end
	end
	return false, dataList[1]
end