module ("MapJunTuanNpcFight_Result",package.seeall)
local curLayer = nil
local widget = nil

local state = false
function exitUI()
	if curLayer ~= nil and widget ~= nil then
		curLayer:removeWidget(widget)
		widget 		= nil
		curLayer 	= nil

		LM.STATE_11 = 0
	end
	state =  false
end

local function initPub()
	local btn_exit 		= tolua.cast( curLayer:getWidgetByName("Button_tuichu"), "Button" )
	local btn_chongBo 	= tolua.cast( curLayer:getWidgetByName("Button_chongbo"), "Button" )

	local img_result1 = tolua.cast( curLayer:getWidgetByName("ImageView_result1"), "ImageView" )
	local img_result2 = tolua.cast( curLayer:getWidgetByName("ImageView_result2"), "ImageView" )

	local rewardTag = {}
	rewardTag[1] = tolua.cast( curLayer:getWidgetByName("Label_jiangli_1"), "Label" )
	rewardTag[2] = tolua.cast( curLayer:getWidgetByName("Label_jiangli_2"), "Label" )
	rewardTag[3] = tolua.cast( curLayer:getWidgetByName("Label_jiangli_3"), "Label" )
	for i=1,3 do
		rewardTag[i]:setVisible(false)
		rewardTag[i]:setText("")
	end
	btn_exit:setPosition(ccp(UseW, 0))


	local function btnCallback( sender, eventType )
    	if eventType == PT.ccs.TouchEventType.ended then
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_exit then
				FightRewardData.ClearReWardDataList()
				exitUI()
				MapJunTuanFight.exitUI()
				guideFactory.CheckGuideProcess(LM.STATE_2)
			elseif _btn == btn_chongBo then
				exitUI()
				MapJunTuanFight.rePlayJunTuanNpcFight()
			end
		end
	end

    btn_exit:addTouchEventListener( btnCallback )
	btn_chongBo:addTouchEventListener( btnCallback )

	local resultFight = JTFightData.getFightResult()
	if resultFight == 0 then --失败
		img_result1:loadTexture(resultImgPath[9][1])
		img_result2:loadTexture(resultImgPath[9][2])
	elseif resultFight == 1 then --胜利
		img_result1:loadTexture(resultImgPath[4][1])
		img_result2:loadTexture(resultImgPath[4][2])
	end

	local rewardData = FightRewardData.getReWardDataList()
	local rewardNum = #rewardData
	print("rewardNum === " .. rewardNum)
	if rewardNum > 3 then
		print("获取奖励大于3个请修改UI 。。。 ")
		return
	end

    ---[[
	for i=1, rewardNum do
		local data = rewardData[i]
		local _type = data["Type"]
		local _getNumOrId = data["NumOrId"] 
		local str = nil
		local colorIdx = 1
		if _type == 0 then--0为银币
			str =  _getNumOrId .. "银币"

		elseif _type == 1 then--1为金币
			str =  _getNumOrId .. "金币"

		elseif _type == 2 then--2为粮草
			str =  _getNumOrId .. "粮草"
		elseif _type == 3 then--3为军功
			str =  _getNumOrId .. "军功"
		elseif _type == 4 or _type == 5 then--4为挑战npc过关奖励--5为首次过关卡奖励
			local goodsDes = Des.getGoodsDesFromId( _getNumOrId )
			str = goodsDes["goodsName"]
			colorIdx = goodsDes["goodsQuality"]
		elseif _type == 6 then--6为将领
			local generalDes = Des.getGeneralDesFromId( _getNumOrId )
			str = generalDes["generalName"]
		elseif _type == 7 then--7为军令
			str =  _getNumOrId .. "军令"
		elseif _type == 8 then--8为荣誉
			str =  _getNumOrId .. "荣誉"
		elseif _type == 9 then--9为民忠
			str = ""
		elseif _type == 10 then--10为农场
			str = ""
		elseif _type == 11 then--11为铁矿
			str = ""
		end

		rewardTag[i]:setText(str)
		rewardTag[i]:setVisible(true)

		AudioEngine.playEffect("4_4.wav", false)
		--print( "colorIdx === " .. colorIdx )
		--print("i === " .. i)
		local r = GoodsColorTab[colorIdx][1]
		local g = GoodsColorTab[colorIdx][2]
		local b = GoodsColorTab[colorIdx][3]
		rewardTag[i]:setColor(ccc3( r, g, b ))
	end
end

function enterUI()
	if state == false then
		state = true
	else
		return 
	end
   	LM.STATE_11 = UI_JunTuan_Fight_Result
    curLayer = LM.getLayer11()
    widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanNpcFightResult.json")  

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    --[[
   	0为平局
	1为险胜
	2为小胜
	3为胜利
	4为大胜
	5为完胜
	6为惜败
	7为小败
	8为失败
	9为大败
	10为完败
	]]
	local resultImgPath = {
		{"floor+19_zhandou.png", "floor+20_zhandou.png"},
		{"floor+21_zhandou.png", "floor+25_zhandou.png"},
		{"floor+22_zhandou.png", "floor+25_zhandou.png"},
		{"floor+25_zhandou.png", "floor+26_zhandou.png"},
		{"floor+23_zhandou.png", "floor+25_zhandou.png"},
		{"floor+24_zhandou.png", "floor+25_zhandou.png"},
		{"floor+30_zhandou.png", "floor+31_zhandou.png"},
		{"floor+29_zhandou.png", "floor+31_zhandou.png"},
		{"floor+32_zhandou.png", "floor+31_zhandou.png"},
		{"floor+28_zhandou.png", "floor+31_zhandou.png"},
		{"floor+27_zhandou.png", "floor+31_zhandou.png"},
	}

	initPub()
	guideFactory.CheckGuideProcess( LM.STATE_11 )
end