module ("Pop3_JunTuanZhan_Help",package.seeall)

local curLayer = nil
local widget = nil


local btn_Close = nil
local lbl_RoleNum = nil
local _scrollviewRoleList = nil

function flushRoleNumInRom()
	local curNum, maxNum = JTNpcRoomData.getPerSentSize()
	lbl_RoleNum:setText( curNum .. "/" .. maxNum )
end

function flushScrollview()
	_scrollviewRoleList:removeAllChildren()

	local cell_disY = 3
    local cell_H = 46
    --可视区域
    local view_W = _scrollviewRoleList:getSize().width 
    local view_H = _scrollviewRoleList:getSize().height 

    local dataList = FindHelpData.getHelpDataList()
    local Datanum = #dataList
    if Datanum == 0 then
    	return
    end
    _scrollviewRoleList:setInnerContainerSize( CCSize(view_W, cell_H*Datanum+(Datanum-1)*cell_disY) )

    --滑动区域
    local scroll_W = _scrollviewRoleList:getInnerContainerSize().width
    local scroll_H = _scrollviewRoleList:getInnerContainerSize().height

    
    local cell_X, cell_Y = scroll_W/2, scroll_H-cell_H/2
    local countryName = {"魏国", "蜀国", "吴国"}

	local function AddTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			local inteam = dataList[tag+1]["InTeam"]
			local teamId = JTNpcRoomData.getTeamId() --房间标识
			local charpterId, NpcId, _ = PT.getId()

			print("teamId == " .. teamId)
			print("charpterId == " .. charpterId)
			if inteam == 1 then
				protoSend0x0528( 2,  tag, teamId, charpterId) --踢出队伍
			else
				protoSend0x0528( 1,  tag, teamId, charpterId) --拉入队伍
			end
		end
	end

    for i=1, Datanum do
    	
    	local data = dataList[i]
    	local ifInTeam = data["InTeam"]
    	local name = data["Name"]
    	local lv = data["Lv"]
    	local Camp = data["Camp"]
    		local lbl_name = Label:create()
			lbl_name:setText( name )
			lbl_name:setFontSize(18)
			lbl_name:setAnchorPoint( ccp(0.5, 0.5) )
    		--lbl_name:setColor( ccc3(255, 0, 0) )
    		lbl_name:setPosition(ccp(90, cell_Y))

    	_scrollviewRoleList:addChild(lbl_name)
    		if ifInTeam ==1 then
    			local size = lbl_name:getContentSize()

    			local imageView = ImageView:create()
				imageView:loadTexture("floor+5_tong.png")
				imageView:setAnchorPoint( ccp(0, 0.5) )
				imageView:setPosition( ccp( 0, cell_Y ) )
				_scrollviewRoleList:addChild( imageView )
    		end


    		local lbl_country = Label:create()
			lbl_country:setText( countryName[Camp+1] )
			lbl_country:setFontSize(18)
			lbl_country:setAnchorPoint( ccp(0.5, 0.5) )
    		--lbl_country:setColor( ccc3(255, 0, 0) )
    		lbl_country:setPosition(ccp(210, cell_Y))
    	_scrollviewRoleList:addChild(lbl_country)

    		local lbl_lv = Label:create()
			lbl_lv:setText( lv .. "级" )
			lbl_lv:setFontSize(18)
			lbl_lv:setAnchorPoint( ccp(0.5, 0.5) )
    		--lbl_lv:setColor( ccc3(255, 0, 0) )
    		lbl_lv:setPosition(ccp(295, cell_Y))
    	_scrollviewRoleList:addChild(lbl_lv)

			local btn_control = Button:create()
		    btn_control:setTouchEnabled(true)
		    btn_control:setScale(0.6)
		    btn_control:setTag(i-1)
		    btn_control:loadTextures("button12_tong_1.jpg", "button12_tong_2.jpg", "")
		    btn_control:setAnchorPoint(ccp(0.5,0.5))
		    btn_control:setPosition( CCPoint( 450, cell_Y ) )
		   	btn_control:addTouchEventListener( AddTouchCB )

			   	local lbl_Zi = Label:create()
			   	if ifInTeam == 1 then
					lbl_Zi:setText( "踢出队伍" )
				else
					lbl_Zi:setText( "拉入队伍" )
				end
				lbl_Zi:setFontSize(24)
				lbl_Zi:setAnchorPoint( ccp(0.5, 0.5) )
	    		lbl_Zi:setColor( ccc3(239, 224, 199) )
	    		lbl_Zi:setPosition(ccp(0, 0))
    		btn_control:addChild(lbl_Zi)

		_scrollviewRoleList:addChild(btn_control)

    	cell_Y = cell_Y - cell_H -cell_disY
    end
end
local function initPub()

	btn_Close 			= tolua.cast( curLayer:getWidgetByName("Button_close"), "Button")
	lbl_RoleNum 		= tolua.cast( curLayer:getWidgetByName("Label_1115"), "Label")
	_scrollviewRoleList = tolua.cast( curLayer:getWidgetByName("ScrollView_Result"), "ScrollView")


	local function closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			exitUI()
		end
	end

	btn_Close:setTouchEnabled(true)
	btn_Close:addTouchEventListener( closeCB )

	flushRoleNumInRom()

	flushScrollview()

end



function exitUI()
    if curLayer ~= nil and widget ~= nil then
        curLayer:removeWidget(widget)
        --curLayer:clear()
        widget = nil
        curLayer = nil
        
        LM.STATE_4 = 0
    end


end

function enterUI()
    LM.STATE_4 = UI_ZhengZhan_JunTuanNpc_Help

    curLayer = LM.getLayer4()
    widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_ZhengZhan_Pop3_Help.json")  

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    initPub()
end
