module ("PT", package.seeall)
ccs = ccs or {}

ccs.TouchEventType = 
{
    began = 0,
    moved = 1,
    ended = 2,
    canceled = 3,
}

ccs.LoadingBarType = 
{ 
    left = 0, 
    right = 1,
}

ccs.CheckBoxEventType = 
{
    selected = 0,
    unselected = 1,
}

ccs.SliderEventType = 
{
    percent_changed = 0
}

ccs.TextFiledEventType = 
{
    attach_with_ime = 0,
    detach_with_ime = 1,
    insert_text = 2,
    delete_backward = 3,
}

ccs.LayoutBackGroundColorType = 
{
    none = 0,
    solid = 1,
    gradient = 2,
}

ccs.LayoutType = 
{
    absolute = 0,
    linearVertical = 1,
    linearHorizontal = 2,
    relative = 3,
}

ccs.UILinearGravity = 
{
    none = 0,
    left = 1,
    top = 2,
    right = 3,
    bottom = 4,
    centerVertical = 5,
    centerHorizontal = 6,
}

ccs.SCROLLVIEW_DIR = {
    none = 0,
    vertical = 1,
    horizontal = 2,
    both = 3,
}

ccs.PageViewEventType = {
   turning = 0,  
}

ccs.ListViewEventType = {
    init_child = 0,
    update_child = 1,
}

ccs.ListViewDirection = {
    none = 0,
    vertical = 1,
    horizontal = 2,
}

UI_State = -1 --记录ui状态

local fight_CharperId = 0 --记录战斗章节id
local fight_NpcId     = 0 --记录战斗npcid
local fight_IfForce   = 0 --记录当前是否强攻

function setId(_chapId, _npcId, _ifforce)
    fight_CharperId = _chapId
    fight_NpcId = _npcId
    fight_IfForce = _ifforce
end

function getId()
    return fight_CharperId, fight_NpcId, fight_IfForce
end
function clearId()
    fight_CharperId = 0
    fight_NpcId = 0
    fight_IfForce = 0
end



function copyTable(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end
---递归隐藏一个widget面板
hideWidget = nil
hideWidget = function(_widget)

    local array = _widget:getChildren()
    local len   = array:count()
    
    _widget:setTouchEnabled(false)
    _widget:setVisible(false)

    for i=0,len-1 do
        local widgetson = tolua.cast( array:objectAtIndex(i), "Widget" )
        widgetson:setTouchEnabled( false )
        widgetson:setVisible( false )
        if widgetson:getChildren():count() > 0 then
            hideWidget( widgetson )
        end
    end

end
--递归显示一个widget面板
showWidget = nil
showWidget = function(_widget)

    local array = _widget:getChildren()
    local len   = array:count()

    _widget:setTouchEnabled( true )
    _widget:setVisible( true )
    
    for i=0, (len-1) do
        local widgetson = tolua.cast( array:objectAtIndex(i), "Widget" )
        widgetson:setTouchEnabled( true )
        widgetson:setVisible( true )
        if widgetson:getChildren():count() > 0 then
            showWidget( widgetson )
        end
    end
end


local writePath = CCFileUtils:sharedFileUtils():getWritablePath()
local targetPlatform = CCApplication:sharedApplication():getTargetPlatform()
--local filePath_android = "/mnt/sdcard/hfsg/"
local filePath_android =writePath .. "hfsg/"

print("-------------------ttttt" .. writePath)
if ifTencentMsdk then
    --filePath_android = "/mnt/sdcard/hfsg/"
    filePath_android = writePath .. "hfsg/"

else
    --filePath_android = "/mnt/sdcard/hfsgCom/"
    filePath_android =writePath .. "hfsgCom/"

end


--获取保存上一次登录的服务器ip地址、port、name

function saveServer(_path, _data)

  local buffer = {}
    --table_insert(buffer,pack("P",_data["ip"]))
    --table_insert(buffer,pack("P",_data["port"]))
    --table_insert(buffer,pack("P",_data["name"]))    
    table_insert(buffer,pack("h",_data["serverId"]))
    local file = io.open( writePath .. _path, "w");
    if(file) then
        for i,v in pairs(buffer) do
            file:write(v)
            --G.LOG.debug("record save",v,string.len(v))
        end
        file:close();
        return true
    else
        return false
    end
end

function getLastServer(_path )
    local data = {}
    local buffer = nil
    local file = io.open( writePath .. _path, "r")    
    if file then
        buffer = file:read("*a") -- i've also tried "*all" as described in PIL
        file:close()
        if buffer == nil then
            return nil
        end
    else 
        return nil
    end

    local pos = 1
    --pos,data["ip"]         = unpack(buffer,"P",pos)
    --pos,data["port"]       = unpack(buffer,"P",pos)
    --pos,data["name"]       = unpack(buffer,"P",pos)
    pos,data["serverId"]     = unpack(buffer,"h",pos)
    return data
end


--获取和保存账号
function getAccount( _path )
    -- body
    local data = {}
    local buffer = nil
    local file = io.open( writePath .. _path, "r")
    if file then
        buffer = file:read("*a") -- i've also tried "*all" as described in PIL
        file:close()
        if buffer == nil then
            return nil
        end
    else 
        return nil
    end

    local pos = 1
    pos,data["name"]         = unpack(buffer,"P",pos)
    pos,data["password"]     = unpack(buffer,"P",pos)
    return data
end

function saveAccount( _path, _data )
    local buffer = {}
    table_insert(buffer,pack("P",_data["name"]))
    table_insert(buffer,pack("P",_data["password"]))    
    local file = io.open( writePath .. _path, "w");
    if(file) then
        for i,v in pairs(buffer) do
            file:write(v)
            --G.LOG.debug("record save",v,string.len(v))
        end
        file:close();
        return true
    else
        return false
    end
end


--序列化和反序列化table
function serialize(obj)  
    local lua = ""  
    local t = type(obj)  
    if t == "number" then  
        lua = lua .. obj  
    elseif t == "boolean" then  
        lua = lua .. tostring(obj)  
    elseif t == "string" then  
        lua = lua .. string.format("%q", obj)  
    elseif t == "table" then  
        lua = lua .. "{\n"  
    for k, v in pairs(obj) do  
        lua = lua .. "[" .. serialize(k) .. "]=" .. serialize(v) .. ",\n"  
    end  
    local metatable = getmetatable(obj)  
        if metatable ~= nil and type(metatable.__index) == "table" then  
            for k, v in pairs(metatable.__index) do  
                lua = lua .. "[" .. serialize(k) .. "]=" .. serialize(v) .. ",\n"  
            end  
        end  
        lua = lua .. "}"  
    elseif t == "nil" then  
        return nil  
    else  
        error("can not serialize a " .. t .. " type.")  
    end  
    return lua  
end  
  
function unserialize(lua)  
    local t = type(lua)  
    if t == "nil" or lua == "" then  
        return nil  
    elseif t == "number" or t == "string" or t == "boolean" then  
        lua = tostring(lua)  
    else  
        error("can not unserialize a " .. t .. " type.")  
    end  
    lua = "return " .. lua  
    local func = loadstring(lua)  
    if func == nil then  
        return nil  
    end  
    return func()  
end  
--[[  
data = {["a"] = "a", ["b"] = "b", [1] = 1, [2] = 2, ["t"] = {1, 2, 3}}  
local sz = serialize(data)  
print("序列化 ===== " .. sz)  
print("---------")  
local remTab = unserialize(sz)
print("反序列化 === " .. remTab["a"])
--print(serialize(unserialize(sz)))  
--]]

function saveGuidePro(_path, _data)
    local path =""
    if (kTargetAndroid == targetPlatform) then
        path = filePath_android .. _path
    else
        path = writePath .. _path
    end
   
    local file = io.open( path, "w+")
    if(file) then
        local str = serialize(_data)  
        file:write(str)
        file:close()
        return trues
    else
        return false
    end
   --[[
    local buffer = {}
    local size = #_data
    print("size == " .. size)
    for i=1, size do
        if i == 1 then
            table.insert(buffer,pack("c",_data[i]))
        else
            table.insert(buffer,pack("c",_data[i]))
        end
    end
    local path = writePath .. _path
    print("path == " .. path)
    local file = io.open( path, "w+");
    if(file) then
        for i,v in pairs(buffer) do
            file:write(v)
            --G.LOG.debug("record save",v,string.len(v))
        end

        file:close();
        print("保存引导文件成功....")

        return true
    else
        print("保存引导文件失败....")
         PT.UI_State=curUi
        return false
    end
--]]

end
--获取、保存引导状态记录
function getGuidePro(_path)
    local data = {}
    local buffer = nil 

    local path =""
    if (kTargetAndroid == targetPlatform) then
        path = filePath_android .. _path
    else
        path = writePath .. _path
    end
    
    local file = io.open( path, "r+")
    if file then
        buffer = file:read("*a")
        file:close()
        data = unserialize(buffer)

        return data
    else
        return nil
    end
--[[
    local data = {}
    local buffer = nil

    local file = io.open( writePath .. _path, "r+")
    print(writePath .. _path)
    --print("open file == " .. io.type(file))
    --if file then
    if io.type(file) ~= nil then
        print("open file == " .. io.type(file))
        print("在这里开始了... ")
        buffer = file:read("*a") -- i've also tried "*all" as described in PIL
        
        if buffer == nil then
            file:close()
            return nil
        end
    else 
        print("在这里返回了... ")
        return nil
    end

    local pos = 1
    pos,data[1]    = unpack(buffer,"c",pos)

    for i=1, data[1] do
        pos,data[i+1]     = unpack(buffer,"c",pos)
    end
    file:close()
    return data
--]]
end

--[[
    data = {19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0, 190}
    PT.saveGuidePro("GuildePro.lua", data)
    local data = PT.getGuidePro("GuildePro.lua")
    for i=1, #data do
        print("guide pro  == " .. data[i])
    end
--]]

function gerStringFromMilSecond( _milSecond )
    local _miao = _milSecond
    local _fen = 0
    local _shi = 0
    local _miaoTT = 0
    _fen, _miao = math_modf(_miao/60)
    _shi, _fen = math_modf(_fen/60)
    _fen,_ = math_modf(_fen*60)
    _miao,_miaoTT = math_modf(_miao*60)
    if _miaoTT > 0.5 then
        _miao = _miao + 1
    end
    --print(_shi .. ":" .. _fen .. ":" .. _miao)
    local str = ""

    if _shi < 10 then
        str = str .. "0" .. _shi .. ":"
    else
        str = str .. _shi .. ":"
    end

    if _fen < 10 then
        str = str .. "0" .. _fen .. ":"
    else
        str = str .. _fen .. ":"
    end

    if _miao < 10 then
        str = str .. "0" .. _miao
    else
        str = str .. _miao
    end
    --print(str)
    return str
end

function registerExitApp(curLayer)
    curLayer:setKeypadEnabled(true)
    local function KeypadHandler(strEvent)
        if "backClicked" == strEvent then
            --CCDirector:sharedDirector():endToLua()
            print("是否确认退出游戏？--------------------------")
            if ifMengXiangSdk then
                TencentMsdk:MyMengExitOrChange(2)
            elseif ifYouLeSdk then
                TencentMsdk:MyYouleExitOrChange(2)
            else
                Pop3_XFTiShi.enterUI( 10000,  "是否确认退出游戏？" )
            end
        elseif "menuClicked" == strEvent then
            
        end
    end 
    curLayer:registerScriptKeypadHandler(KeypadHandler)
end

function getNumHanZiFromNum( num )
    if num > 10000 then
        print("要转换的数字超过了999了 。。。")
        return
    end
    local iii = num
    local ilV = { "千","百", "十", "个"}
    local ttt = {1000,100, 10, 1}
    local str = ""
    for i = 1, 4 do
        local mmm = math_floor(iii/ttt[i])
        print( "mmm === " .. mmm )
        if mmm == 1 then
            str = str .. "一"
        elseif mmm == 2 then
            str = str .. "二"
        elseif mmm == 3 then
            str = str .. "三"
        elseif mmm == 4 then
            str = str .. "四"
        elseif mmm == 5 then
            str = str .. "五"
        elseif mmm == 6 then
            str = str .. "六"
        elseif mmm == 7 then
            str = str .. "七"
        elseif mmm == 8 then
            str = str .. "八"
        elseif mmm == 9 then
            str = str .. "九"
        end
        iii = iii - mmm*ttt[i]
        if mmm ~= 0 and i < 4 then
            str = str .. ilV[i] 
        end
    end 
    print("装换字符是 == " .. str)
    return str
    
end
-- 1234567890 ->1,234,567,890
function parseNum(_num)
    local strK = tostring(_num)

    local function _parse(str)
        local len = string.len(str)
        if len > 3 then
            --local str1 = string.sub(str, len-2, len)
            --local str2 = string.sub(str, 1, len-3)
            local str1 = string.sub(str, -3, -1)
            local str2 = string.sub(str, 1, -4)
            print(str1)
            return _parse(str2) .. "," .. str1

        else
            return str
        end
    end
    return _parse(strK)
end

function hideButton(btn,id) --功能开启de按钮隐藏
   -- local _btn = tolua.cast(btn, "Button")
    if id==nil then
        btn:setVisible(false)
        btn:setTouchEnabled(false) 
        return
    end
    local str=Des.getFunctionDesFromId(id)
    print("str"..str)
    if CityData.canOpenFuncByIndex(id)== false then    
            btn:setVisible(false)
            btn:setTouchEnabled(false) 
    end

end
function popTips(id) --功能开启de消息提示
    -- local str=Des.getFunctionDesFromId(id)
    -- if str ~="" then
    --    Pop3_TS_Result.enterUI(str) 
    -- end
end
function hideManyBtn(tab,id,btn)
        if CityData.canOpenFuncByIndex(id) then
            tab[#tab+1]=btn
        else
            PT.hideButton(btn)
        end
 end 

---获取女神星阶
    --当前品阶星级
function checkeGodQuality(_star)
    if _star < 11 then
        return 0, _star
    elseif _star < 22 then
        return 1, _star - 11
    elseif _star < 33 then
        return 2, _star - 22
    elseif _star < 44 then
        return 3, _star - 33
    elseif _star < 55 then
        return 4, _star - 44
    end
end


function getSizeSubStr(Str)
    --attention "<>"作为特殊字符处理，不能再字符串随意出现
    --[[
    test:
        local str = "vvv<4:aaa>ddd<4:bbb>hhh"
        local _newstr,_size =   getSizeSubStr(str)
        print("end str = " .. _newstr)  -->vvvaaadddbbbhhh
        print("end size = " .. _size)   -->15
    --]]
    local newStr = ""

    local function inTool(_str)
        --print("----str = " .. _str)
        local _len = string_len( _str )
        --print(_len)
        local _beg,_end = string_find(_str, "<")
        --print(_beg)
        --print(_end)
        if _beg == nil or _beg >= _len then
            --print("end")
            newStr = newStr .. _str
            --print("end  ==== " .. newStr)

        else
            local t_str = string_sub(_str, 1, _beg-1)
            newStr = newStr ..  t_str

            _str = string_sub(_str, _end+1, _len)

            --print("1 = " .. _str)
            _len = string_len(_str)
            _beg,_end = string_find(_str, ":")

            _str = string_sub(_str, _end+1, _len)
           -- print("2 = " .. _str)

            _len = string_len(_str)
            _beg,_end = string_find(_str, ">")
            t_str = string_sub(_str, 1, _beg-1)
            --print("3 = " ..  t_str)

            newStr = newStr ..  t_str

            _str = string_sub(_str, _beg+1, _len)
            --print("4 = " ..  _str)
            inTool(_str)
        end

    end
    inTool(Str)
    return newStr, string_len(newStr)
end