--module ("SokcetMachine", package.seeall)

require "socket"
require "bit"
--require "LuaScript/SocketModule/SocketParse"
-------------------------------
--联网状态
SCK_STATE_IDLE			= 0
SCK_STATE_TRYCONNECT	= 1
SCK_STATE_CONNECTING	= 2
SCK_STATE_WORKING		= 3

-------------------------------
local _M = {}

local bDebugSocket	= true
local bDumpPacket	= true
local key = 135
hSocket = nil

sendBuffer = {}
recvBuffer = {}

readFD 	= {}
writeFD = {}

mHost = nil
mPort = nil

mFuncOnSuccess = nil
mFuncOnFail = nil

--SERVER_ADDR_DEFAULT = "192.168.0.17"
--SERVER_PORT_DEFAULT = "6901"

socketState = SCK_STATE_IDLE

MAX_RECEIVE_BYTES = 20000



--初始化
function _M:SocketInit()
	local scheduler = CCDirector:sharedDirector():getScheduler()
    scheduler:scheduleScriptFunc( self.SocketLoop, 1, false)
end

function _M:SocketConnect(host, port, funcSuc, funcFail)
	if hSocket then
		print("hSocket:close()")
		hSocket:shutdown("both")
		hSocket:close()
		hSocket = nil
		sendBuffer = {}
		recvBuffer = {}
		socketState = SCK_STATE_IDLE
	end
if nil ~= host then
print("SocketConnect host = " .. host)
print("SocketConnect port = " .. port)
end
	mHost = host or SERVER_ADDR_DEFAULT
	mPort = port or SERVER_PORT_DEFAULT

print("SocketConnect mHost = " .. mHost)
print("SocketConnect mPort = " .. mPort)

	mFuncOnSuccess = funcSuc
	mFuncOnFail = funcFail

	recvBuffer = {}
	sendBuffer = {}
	socketState = SCK_STATE_TRYCONNECT
end
--重连
function _M:SocketReconnect(host, port, funcSuc, funcFail)
	print("SocketReconnect host" .. host)
	print("SocketReconnect port" .. port)
	self:SocketConnect( host, port, funcSuc, funcFail )
end

function _M:SocketSent(data, ifloading)
	
	print("socketState == " .. socketState)
	if (socketState == SCK_STATE_WORKING) then
		if ifloading == nil then
			Loading:LoadingShow()
		end
		table.insert( sendBuffer, SCpack(data) )
		local wholebuffer = table.concat( sendBuffer )
        local keybuffer = {}
		if string.len(wholebuffer) > 0 then
			if bDumpPacket then
				print("wholebuffer ===== " .. wholebuffer)
				print('new send,package data:'..hex(wholebuffer))
			end
		
			local sent, err = nil
			local Xbuffer = nil
if ifOldServer then	
			---[[
             for i=1,string.len(wholebuffer) do
               	table.insert(keybuffer, string.char(bit.bxor(string.byte(wholebuffer,i),key)))
             end
            Xbuffer = table.concat( keybuffer )
            sent, err = hSocket:send(Xbuffer)
            --]]
else
			sent, err = hSocket:send(wholebuffer)
end
			if sent == nil then	-- 发送失败
				sent = 0
				-- 这里表示已经发送失败了，切换状态，调用失败函数
				if hSocket then
					hSocket:close()
					hSocket = nil
					sendBuffer = {}
					recvBuffer = {}
					socketState = SCK_STATE_IDLE
				end
				--todo 提示发送失败
				print("发送失败！")
				return
			else
			--打印发送数据
			if bDebugSocket then
					print(string.format("sent %d ", sent))
				end
			end

if ifOldServer then	
			---[[
			-- 抽取尚未发送成功的数据
			Xbuffer = string.sub(Xbuffer,sent + 1)
			sendBuffer = {}
			if Xbuffer then 
				if string.len( Xbuffer ) > 0 then
					table.insert( sendBuffer, Xbuffer )
				end
			end
			--]]
else
			wholebuffer = string.sub(wholebuffer,sent + 1)
			sendBuffer = {}
			if wholebuffer then 
				if string.len( wholebuffer ) > 0 then
					table.insert( sendBuffer, wholebuffer )
				end
			end

end
		end
	end
end


function SocketCheckParse()
	
	local bKeepRecv = true
	local s, status, rest = nil, nil, nil
	-- 接收完所有数据
	while bKeepRecv do
		s, status,rest = hSocket:receive( MAX_RECEIVE_BYTES )
		if (rest~=nil) then
			s = rest
		end

		if (s ~=nil and s ~= "") then
			table.insert( recvBuffer, s )
		else
			bKeepRecv = false
		end
	end
	local maxlen = 8*1024
	if  #(recvBuffer) > 0 then
		--print('new receive packagelen:'..#recvBuffer)
		if bDumpPacket then
			local str = hex( table.concat( recvBuffer ) )
			local allstrlen = string.len(str)
			print("allstrlen ==== " .. allstrlen)
			local num = math.ceil(allstrlen/maxlen)
			local begpos = 0
			local endpos = 0
			local printlen = 1
			for i=1,num do
				if allstrlen > maxlen then
					printlen = maxlen
				else
					printlen = allstrlen
				end
				begpos = endpos + 1
				endpos = begpos+printlen-1
				print("new receive package_" .. i .. ":" .. string_sub(str, begpos, endpos) )
				allstrlen = allstrlen - printlen
			end
		end
		local remain = nill
if ifOldServer then
        ---[[
        local keybuffer = {}
        
        if recvBuffer ~= nil then
        	local str = table.concat( recvBuffer ) 
			local allstrlen = string.len(str)
             for i=1,allstrlen do
                table.insert(keybuffer, string.char(bit.bxor(string.byte(str,i),key)))
             end
        end

		local remain = SCparseAll(table.concat( keybuffer ))
		--]]
else
		remain = SCparseAll(table.concat( recvBuffer ))		
end
		HeartManager.timeHeartClear()
		--remain = nil
		recvBuffer = {}
		if (remain ~=nil and remain~="" ) then
			table.insert( recvBuffer, remain )
		end
		--[[todo:对不全cmd进行处理
		--没有封包，这里给提示
		socketUtil:hideMsgBox()
		
		if nil == remain then
			socketUtil:showErrorBox("no cmd here", "no cmd here2"  )
		end
		--]]
	end
end

--主循环事件
function _M:SocketLoop(t)
	HeartManager.timeHeartCount()
	-- body
	--print("SocketLoop ... " .. socketState)
	if socketState ==  SCK_STATE_IDLE then
		--print("socketloop == 1...")
		-- 什么也别干
	elseif socketState ==  SCK_STATE_TRYCONNECT then
		--print("socketloop == 2...")
		hSocket = socket.tcp()
		hSocket:setoption("tcp-nodelay", true)
		hSocket:settimeout(0)
		hSocket:connect( mHost, mPort )
		table.insert( readFD, hSocket )
		table.insert( writeFD, hSocket )
		socketState = SCK_STATE_CONNECTING

	elseif socketState == SCK_STATE_CONNECTING then
		--print("socketloop == 3...")
		-- select 检测到服务器的连接状态，如果
		local _,_,error = socket.select(nil, writeFD, 0)
		if error == nil then	-- 正常的状态
			-- 连接成功,
			--print("socketloop == 4...")
			socketState = SCK_STATE_WORKING 
			if (mFuncOnSuccess) then
				mFuncOnSuccess()
			end
			
		elseif error == "timeout" then
			--print("error1 == " .. error)
			-- 正常的错误信息
			-- TODO 如果实在是无法连接的错误信息，需要检查
		else
			-- TODO 如果实在是无法连接
			--print("error2 == " .. error)
			socketState = SCK_STATE_IDLE 
			if (mFuncOnFail) then
				mFuncOnFail()
			end
		end
	end
	
	if socketState == SCK_STATE_WORKING then
		local rt,_,error = socket.select(readFD,nil,0)
		if (error == nil) or (error =="timeout") then
			-- 读取数据
			SocketCheckParse()

		elseif error ~="timeout" then
			--print("error3 == " .. error)
			-- 这里表示已经发送失败了，切换状态，调用失败函数
			if hSocket then
				hSocket:close()
				hSocket = nil
				sendBuffer = {}
				recvBuffer = {}
				socketState = SCK_STATE_IDLE
			end
			--todo断网处理
			return
		end

	end 

end

--[[
    hSocket = socket.tcp()
    hSocket:setoption("tcp-nodelay", true)
    hSocket:settimeout(0)
    hSocket:connect("192.168.0.17","6901")
--]]

return _M

