module ("NpcListData",package.seeall)
--章节列表数据
NpcTemplet = {
--[[
	Id 			= 0, --Npc id
	State 		= 0, --关卡状态 0--没打 1--打通  2--正在打 /// 隐藏关卡: 0--关闭 1--开启 2-开启并打通
	NpcLv 		= 0, --关卡npc等级
	GetExploit 	= 0, --此关卡获得的军工
	BeatNum 	= 0, --本关卡的攻打次数
	BeatMax 	= 0, --本关卡的攻打上限
	HideTime 	= 0, --隐藏关卡的倒计时，非隐藏关卡无意义
	DefaltTime  = 0, --隐藏关卡的默认最大倒计时事件，正常关卡此数据无意义
	lostOrder	= 0, --攻打本关卡消耗的军令
	DropId 		= 0, --掉落id
	RecuitId 	= 0, --可招募将领id
	ArmyNpc 	= 0, --0为普通npc 1为军团npc
	QGgold 		= 0, --强攻所需的金币
--]]
	ifHide 		= 0, --是否隐藏npc 1是隐藏
	State 		= 0, --关卡状态 0--没打 1--打通  2--正在打 隐藏关卡时：0--关闭 1--开启 2-开启并打通
	BeatNum 	= 0, --本关卡的攻打次数
	BeatMax 	= 0, --本关卡的攻打上限
	HideTime 	= 0, --隐藏npc有意义 当前消失时间
	DefaltTime 	= 0, --隐藏npc有意义 默认消失时间 （无用）
	Id 			= 0, --npc id
	OnlyId 		= "",
	
	NpcLv 		= 0, --关卡npc等级           (无用)
	GetExploit 	= 0, --此关卡获得的军工
	lostOrder	= 0, --攻打本关卡消耗的军令
	DropId 		= 0, --掉落id
	RecuitId 	= 0, --可招募将领id
	ArmyNpc 	= 0, --  					（无用）
	QGgold 		= 0, --强攻所需金币

	ifOpenFirst = 0, --是否第一次通关 --0：不是 1是

}

local _npcDataList = {}
local curNpcId = 0

function addNpcData( _data )
	table_insert( _npcDataList, _data )
	if _data["State"] == 2 then
		curNpcId = _data["Id"]
	end
end
function clearNpcListData()
	_npcDataList = {}
end
function getNpcListData()
	return _npcDataList
end
function getNpcListDataFromLocIdx( idx )
	return _npcDataList[idx]
end
--_ifhide: 	true:隐藏npc 		false：非隐藏npc
function getNpcDataFromId( _id, _ifhide)
	local num = #_npcDataList
	for i=1, num do
		if _ifhide then
			if _npcDataList[i]["ifHide"] ==1 and _npcDataList[i]["Id"] == _id then
				return _npcDataList[i]
			end
		else
			if _npcDataList[i]["ifHide"] ~=1 and _npcDataList[i]["Id"] == _id then
				return _npcDataList[i]
			end
		end
	end
--[[
	if _ifhide then
		local num = #_hideNpcDataList
		for i=1, num do
			if _id == _hideNpcDataList[i]["Id"] then
				return _hideNpcDataList[i]
			end
		end		
	else

		local num = #_npcDataList
		for i=1, num do
			if _id == _npcDataList[i]["Id"] then
				return _npcDataList[i]
			end
		end
	end
--]]
end

function getNpcDataList()
	return _npcDataList
end
--获取当前npc的id
function getCurNpcId()
	return curNpcId
end

--获取当前npc的本地序列
function getCurNpcLocalIdx()
	local num = #_npcDataList
	for i=1, num do
		if curNpcId == _npcDataList[i]["Id"] then
			return i
		end
	end
	return 0
end
--diyici gongji
--[[
function getNpcStatefromId( _id )
	local num = #_npcDataList
	for i=1, num do
		if _id == _npcDataList[i]["Id"] then
			return _npcDataList[i]["State"]
		end
	end
	return 0
end
--]]
function getNpcStatefromId( _id )
	local num = #_npcDataList
	for i=1, num do
		if _id == _npcDataList[i]["Id"] and _npcDataList[i]["ifHide"] ~= 1 then --不是隐藏npc
			if _npcDataList[i]["ifOpenFirst"] == 1 then
			   _npcDataList[i]["ifOpenFirst"] = 0 --新手引导完要清空这个值，防止再次攻打出问题
				return 1
			else
				return 0
			end
		end
	end
	return 0
end
--[[
--新手引导完要清空这个值，防止再次攻打出问题
function clearIfOpenFirst()
	local num = #_npcDataList
	for i=1, num do
		_npcDataList[i]["ifOpenFirst"] = 0
	end
end
--]]
--更新npc关卡的状态和攻打次数
--[[
	每次打通npc进行两次cmd301 flushNpcStata的操作，必须是先告知开通哪个，后告知通关哪个，否则ifOpenFirst属性将都被置0
]]
function flushNpcStata( _ifHide, _npcId, _state, _BeatNum, _gold )
	local num = #_npcDataList
	for i=1, num do
		_npcDataList[i]["ifOpenFirst"] = 0 
		if _npcId == _npcDataList[i]["Id"] and _ifHide == _npcDataList[i]["ifHide"]  then
			if _ifHide == 1 then --如果是隐藏npc

			else
				if _npcDataList[i]["State"] == 2 and _state == 1 then --由正在打变成打通
					_npcDataList[i]["ifOpenFirst"] = 1 --判断为第一次打通，
				end
			end
			
			_npcDataList[i]["State"] = _state
			_npcDataList[i]["BeatNum"] = _BeatNum
			_npcDataList[i]["QGgold"] = _gold
		end
	end
end

function getQGGold(_npcId)
	local num = #_npcDataList
	for i=1, num do
		if _npcId == _npcDataList[i]["Id"] then
			return _npcDataList[i]["QGgold"] 
		end
	end
	return 0
end
function flushHideNpcLableFromId()
	local num = #_npcDataList
	for i=1, num do
		--隐藏npc 隐藏倒计时不为零 状态为开启状态
		if _npcDataList[i]["ifHide"] == 1 and _npcDataList[i]["HideTime"]>0 and _npcDataList[i]["State"]~=0 then
			_npcDataList[i]["HideTime"] = _npcDataList[i]["HideTime"] -1
		end
	end
end
function getNpcOnlyIdFromId(_id)

	local num = #_npcDataList
	for i=1, num do
		if _id == _npcDataList[i]["Id"] then
			return _npcDataList[i]["OnlyId"] 
		end
	end
	return ""
end

------------------------------------------------------------
--军团npc 精英
NpcSplTemplet = {
	Id          = 0,
	State 		= 0, --关卡状态 0--未开启（不显示） 1--打通  2--正在打
	NpcLv 		= 0, --关卡npc等级
	GetExploit 	= 0, --此关卡获得的军工
	lostOrder	= 0, --攻打本关卡消耗的军令
	DropId 		= 0, --掉落id
	RecuitId 	= 0, --可招募将领id
	isAutoCanZhan=0, --是否设置自动参战
	OnlyId = "",

	ifOpenFirst = 0, --是否第一次通关 --0：不是 1是
}
local npcSplList = {}

function addSplNpcData(_data)
	table_insert( npcSplList, _data )
end
function clearSplNpcData()
	npcSplList = {}
end
function flushSplNpcState(_id, _state)
	local num = #npcSplList
	for i=1, num do
		if _id == npcSplList[i]["Id"] then
			if npcSplList[i]["State"] == 2 and _state == 1 then --由正在打到打通，第一次打
				npcSplList[i]["ifOpenFirst"] = 1 
			end
			npcSplList[i]["State"] = _state
		end
	end
end
function getSplNpcStatefromId( _id )
	local num = #npcSplList
	for i=1, num do
		if _id == npcSplList[i]["Id"] then 
			if npcSplList[i]["ifOpenFirst"] == 1 then
				npcSplList[i]["ifOpenFirst"] = 0 --新手引导完要清空这个值，防止再次攻打出问题
				return 1
			else
				return 0
			end
		end
	end
	return 0
end
--获取已开启的精英npc的数据索引 
function getOpenLocTab()
	local dataTab = {}
	local num = #npcSplList
	for i=1, num do
		if npcSplList[i]["State"] ~= 0 then
			table_insert(dataTab, i)
		end 
	end
	return dataTab
end

function getSplDataFromLocIdx(_idx)
	return npcSplList[_idx]
end
function getSplDataFromId(_id)
	local num = #npcSplList
	for i=1, num do
		if npcSplList[i]["Id"] == _id then
			return npcSplList[i]
		end
	end
	return nil
end

------------------------------------------------------------
--[[
--local _hideNpcDataList= {} --无需隐藏npc列表了，合并了
-------隐藏npc数据---------------------
function addHideNpcData( _data )
	table_insert(_hideNpcDataList, _data)
	if _data["State"] == 2 then
		curNpcId = _data["Id"]
	end
end
function clearHideNpcData()
	_hideNpcDataList = {}
end
--更新隐藏npc关卡的状态和攻打次数
function flushHideNpcStata( _npcId, _state, _BeatNum, _gold )
	local num = #_hideNpcDataList
	for i=1, num do
		if _npcId == _hideNpcDataList[i]["Id"] then
			_hideNpcDataList[i]["State"] 	= _state
			_hideNpcDataList[i]["BeatNum"] 	= _BeatNum
			_hideNpcDataList[i]["QGgold"] 	= _gold
			if _state == 0 then
				_hideNpcDataList[i]["HideTime"] = _hideNpcDataList[i]["DefaltTime"]
			end
			--todo:是否需要更新UI
			return 
		end
	end
end
function getHideNpcData()
	return _hideNpcDataList
end
function getHideNpcDataFromIdx(_idx)
	if _idx > #_hideNpcDataList then
		print("error隐藏npc数据不对呀。。。")
	else
		return _hideNpcDataList[_idx]
	end
end

function getHideNpcDataFromId(_Id)
	local num = #_hideNpcDataList
	for i=1, num do
		if _id == _hideNpcDataList[i]["Id"] then
			return _hideNpcDataList[i]
		end
	end
end
function setHideNpcLableFromId(_id, _lbl, _lblBG, _nodNpc)
	local num = #_hideNpcDataList
	for i=1, num do
		if _id == _hideNpcDataList[i]["Id"] then

			_hideNpcDataList[i]["lable"] = _lbl
			_hideNpcDataList[i]["lableBG"] = _lblBG
			_hideNpcDataList[i]["nodeNpc"] = _nodNpc
			return
		end 
	end
end
function clearHideNpcLable()
	local num = #_hideNpcDataList
	for i=1, num do
		_hideNpcDataList[i]["lable"] = nil
		_hideNpcDataList[i]["nodeNpc"] = nil
		_hideNpcDataList[i]["lableBG"] = nil
	end
end
function flushHideNpcLableFromId()
	local num = #_hideNpcDataList
	for i=1, num do
		if _hideNpcDataList[i]["State"] ~= 0 and _hideNpcDataList[i]["HideTime"] > 0 then
			_hideNpcDataList[i]["HideTime"] = _hideNpcDataList[i]["HideTime"] -1
			if _hideNpcDataList[i]["lable"] ~= nil then
				local str = PT.gerStringFromMilSecond( _hideNpcDataList[i]["HideTime"] )
				str = str .. "后消失"
				_hideNpcDataList[i]["lable"]:setText(str)
			end
		else
			if _hideNpcDataList[i]["nodeNpc"] ~= nil then
				_hideNpcDataList[i]["nodeNpc"]:setTouchEnabled(false)
				_hideNpcDataList[i]["nodeNpc"]:setVisible(false)
				_hideNpcDataList[i]["lable"] = nil
				_hideNpcDataList[i]["nodeNpc"] = nil
				_hideNpcDataList[i]["lableBG"] = nil
				--将时间设为默认时间
				_hideNpcDataList[i]["HideTime"] = _hideNpcDataList[i]["DefaltTime"]
			end
		end
	end
end

--]]

